package me.akito123321.valoStrats;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.nimbusds.jose.util.StandardCharset;

import me.akito123321.valoStrats.db.MySQLConfig;

public record Config(
		String host,
		int port,
		String clientId,
		String clientSecret,
		String redirect_url,
		MySQLConfig sqlConfig) {

		public static Config loadConfig(String path) throws IOException {
			Path configPath = Path.of(path);
			if (!Files.exists(configPath)) {
				Files.createFile(configPath);
			}

			Gson gson = new GsonBuilder().setPrettyPrinting().create();

			String configStr = Files.readString(configPath);
			if (configStr.isEmpty()) {
				Config config = new Config(
					"0.0.0.0",
					8080,
					"",
					"",
					"",
					new MySQLConfig(
						"",
						3306,
						"root",
						"root",
						""));
				Files.writeString(configPath, gson.toJson(config), StandardCharset.UTF_8);
				System.out.println("Config file created. Please edit it accordingly");
				System.exit(0);
			}

			return gson.fromJson(configStr, Config.class);
		}
	}
