package me.akito123321.valoStrats.schemas;

import java.util.List;

import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;

@Entity
public class Strat {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	private String title;
	private String description;
	@ManyToOne
	private Group group;
	
	@ElementCollection(fetch = FetchType.EAGER)
	private List<StratState> stratStates;
	
	@OneToMany(fetch = FetchType.EAGER)
	private List<PlayerType> playerTypes;
	
	@ManyToOne
	private Map map;

	public Strat(String title, String description, Group group, List<StratState> stratStates) {
		this.title = title;
		this.description = description;
		this.group = group;
		this.stratStates = stratStates;
	}

	public Strat() {

	}

	public String getId() {
		return id;
	}

	public String getTitle() {
		return title;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public List<StratState> getStratStates() {
		return stratStates;
	}
	
	public void setStratStates(List<StratState> stratStates) {
		this.stratStates =  stratStates;
	}

}
