package me.akito123321.valoStrats.schemas;

import java.util.List;

import jakarta.persistence.Column;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.Lob;
import jakarta.persistence.ManyToOne;

@Entity
public class StratState {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	
	private String description;
	
	@ManyToOne
	private Strat strat;
	
	@Lob
	@Column(length = Integer.MAX_VALUE)
	@ElementCollection(fetch = FetchType.EAGER)
	private List<Lineup> lineups;

	public StratState(String description, Strat strat, List<Lineup> lineups) {
		super();
		this.description = description;
		this.strat = strat;
		this.lineups = lineups;
	}
	
	public StratState() {
		
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getId() {
		return id;
	}

	public Strat getStrat() {
		return strat;
	}

	public List<Lineup> getLineups() {
		return lineups;
	}
	
}
