package me.akito123321.valoStrats.schemas;

import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import com.fasterxml.jackson.annotation.JsonIgnore;

import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToMany;

@Entity(name = "user")
public class StratsUser implements UserDetails {

	private static final long serialVersionUID = 6175503410592822108L;

	@Id
	private String username;
	private String password;
	@ElementCollection(fetch = FetchType.EAGER)
	private List<SimpleGrantedAuthority> authorities;
	private boolean isAccountNonExpired;
	private boolean isAccountNonLocked;
	private boolean isCredentialsNonExpired;
	private boolean isEnabled;

	@ElementCollection(fetch = FetchType.EAGER)
	private Set<String> tokens;
	private String googleUserId;
	private String displayName;

	@ManyToMany(mappedBy = "members")
	@ElementCollection(fetch = FetchType.EAGER)
	@JsonIgnore
	private List<Group> groups;

	public StratsUser() {

	}

	public StratsUser(String googleUserId, String displayName, List<SimpleGrantedAuthority> authorities, String username, String password, boolean isAccountNonExpired, boolean isAccountNonLocked, boolean isCredentialsNonExpired, boolean isEnabled) {
		super();
		this.googleUserId = googleUserId;
		this.displayName = displayName;
		this.authorities = authorities;
		this.username = username;
		this.password = password;
		this.isAccountNonExpired = isAccountNonExpired;
		this.isAccountNonLocked = isAccountNonLocked;
		this.isCredentialsNonExpired = isCredentialsNonExpired;
		this.isEnabled = isEnabled;
		this.tokens = new HashSet<>();
	}

	public String getGoogleId() {
		return googleUserId;
	}

	public String getDisplayName() {
		return displayName;
	}

	public Set<String> getTokens() {
		return tokens;
	}

	@Override
	public Collection<? extends GrantedAuthority> getAuthorities() {
		return authorities;
	}

	@Override
	public String getPassword() {
		return password;
	}

	@Override
	public String getUsername() {
		return username;
	}

	@Override
	public boolean isAccountNonExpired() {
		return isAccountNonExpired;
	}

	@Override
	public boolean isAccountNonLocked() {
		return isAccountNonLocked;
	}

	@Override
	public boolean isCredentialsNonExpired() {
		return isCredentialsNonExpired;
	}

	@Override
	public boolean isEnabled() {
		return isEnabled;
	}

	public List<Group> getGroups() {
		return groups;
	}

}
